<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/03/2009 *
 * ===============                              Last change: 04/03/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : config-global.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Global configuration                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Globale Konfiguration                            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} // END - if

/************************************************************************
 *      PLEASE DO NOT EDIT THE COMMENTS! install.php NEEDS THEM!        *
 ************************************************************************/

if (function_exists('date_default_timezone_set')) {
	// CFG: TIME-ZONE
	@date_default_timezone_set('Europe/Berlin');
} // END - if

// CFG: ERROR_REPORTING
error_reporting(E_ALL | E_STRICT);

// CFG: REGISTER-GLOBALS
@import_request_variables('');

// Detect path
$PATH = str_replace("\\", '/', substr(dirname(__FILE__), 0, -3));

// Configuration include file
require($PATH . 'inc/config-functions.php');

// Wrapper include file
require($PATH . 'inc/wrapper-functions.php');

// Initialize the configuration
initConfig();

// Auto-detection... (patched by "Stelzi" aka. profi-concept, thanks again!)
$URL = 'http://' . getenv('SERVER_NAME') . str_replace("\\", '/', dirname($_SERVER['PHP_SELF']));
while (substr($URL, -1, 1) == '/') { $URL = substr($URL, 0, -1); }

// CFG: HOST-URL (without trailing '/' !)
setConfigEntry('URL', $URL);

// CFG: SERVER-PATH
setConfigEntry('PATH', str_replace("\\", '/', substr(dirname(__FILE__), 0, -3)));

// CFG: VERSION
setConfigEntry('VERSION', 'v0.2.1');

// CFG: AUTHOR
setConfigEntry('AUTHOR' , 'Roland H&auml;der');

// CFG: TITLE
setConfigEntry('TITLE', 'MXChange - Mail Exchange');

// CFG: COPY
setConfigEntry('COPY', 'Copyright &copy; 2003 - 2008, by Roland H&auml;der');

// Connect to the MySQL database...
loadIncludeOnce('inc/mysql-connect.php');

//
?>
