<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/10/2009 *
 * ===============                              Last change: 03/10/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : inc-functions.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for handling include files     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktionen fuer Include-Dateien        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Check if our config file is writeable or not
function isIncludeWriteable ($inc) {
	// Generate FQFN
	$FQFN = sprintf("%sinc/%s.php", getConfig('PATH'), $inc);

	// Abort by simple test
	if ((isFileReadable($FQFN)) && (!is_writeable($FQFN))) {
		return false;
	} // END - if

	// Test write-access on directory
	return is_writeable(dirname($FQFN));
}

// Init INC_POOL
function INIT_INC_POOL () {
	$GLOBALS['inc_pool'] = array();
}

// Setter for INC_POOL
function SET_INC_POOL ($includePool) {
	$GLOBALS['inc_pool'] = (array) $includePool;
}

// Getter for INC_POOL
function GET_INC_POOL () {
	return $GLOBALS['inc_pool'];
}

// Count INC_POOL
function COUNT_INC_POOL () {
	return count($GLOBALS['inc_pool']);
}

// Merge INC_POOL into given
function MERGE_INC_POOL ($includePool) {
	SET_INC_POOL(merge_array(GET_INC_POOL(), $includePool));
}

// Add single include file to INC_POOL
function ADD_INC_TO_POOL ($INC) {
	$GLOBALS['inc_pool'][] = (string) $INC;
}

// Remove an include file from INC_POOL
function REMOVE_INC_FROM_POOL ($INC) {
	// First look it up
	$key = array_search($INC, GET_INC_POOL());

	// Is it valid?
	if ($key !== false) {
		// Then remove it
		unset($GLOBALS['inc_pool'][$key]);

		// And sort the list
		asort($GLOBALS['inc_pool']);
	} // END - if
}

// Load the whole include pool
function LOAD_INC_POOL () {
	foreach (GET_INC_POOL() as $inc) {
		loadIncludeOnce($inc);
	} // END - foreach
}

// [EOF]
?>
