<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/25/2004 *
 * ================                             Last change: 06/25/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : nickname_functions.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Nickname functions                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Nickname-Funktionen                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Checks wether the nickname is active
function NICKNAME_IS_ACTIVE ($uidNick) {
	// By default nothing is found...
	$ret = false;

	// Found in cache?
	if (isset($GLOBALS['cache_array']['nick_active'][$uidNick])) {
		// Use it directly
		$ret = $GLOBALS['cache_array']['nick_active'][$uidNick];

		// Increment cache counter
		incrementConfigEntry('cache_hits');
	} else {
		// Nickname or userid used?
		$nick = NICKNAME_GET_NICK($uidNick);

		// Check for nickname
		$ret = ($nick != $uidNick);

		// Put it in cache
		$GLOBALS['cache_array']['nick_active'][$uidNick] = $ret;
	}

	// Return nickname
	return $ret;
}

// "Getter" for nickname for specfied userid
function NICKNAME_GET_NICK ($userid) {
	// If not found...
	$ret = '';

	// Found in cache?
	if (isset($GLOBALS['cache_array']['nicknames'][$userid])) {
		// Use it directly
		$ret = $GLOBALS['cache_array']['nicknames'][$userid];

		// Increment cache counter
		incrementConfigEntry('cache_hits');
	} else {
		// Init result
		$result = false;

		// Nickname or userid used?
		if (''.round($userid).'' === ''.$userid.'') {
			// Userid given
			$result = SQL_QUERY_ESC("SELECT `nickname`  FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `userid` =%s LIMIT 1",
				array(bigintval($userid)), __FUNCTION__, __LINE__);

			// Found?
			if (SQL_NUMROWS($result) == 1) {
				// Load nickname from database
				list($ret) = SQL_FETCHROW($result);

				// Put it in cche
				$GLOBALS['cache_array']['nicknames'][$userid] = $ret;
			} // END - if

			// Free result
			SQL_FREERESULT($result);
		} else {
			// Direct nickname found!
			$ret = $userid;

			// Put it in cche
			$GLOBALS['cache_array']['nicknames'][$userid] = $ret;
		}
	}

	// Return nickname
	return $ret;
}

//
?>
