<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/30/2004 *
 * ================                             Last change: 07/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File: what-config_admins.php                                         *
 * -------------------------------------------------------------------- *
 * Short description : Configure admin ACLs                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Admin-ACLs einstellen                            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

$SEL = 0;
if (REQUEST_ISSET_POST('sel')) $SEL = countPostSelection();

if ((REQUEST_ISSET_POST('edit')) && ($SEL > 0)) {
	// Edit ACLs
	$OUT = ''; $SW = 2;
	foreach (REQUEST_POST('sel') as $id => $selected) {
		// Load data for the ID
		$result = SQL_QUERY_ESC("SELECT admin_id, action_menu, what_menu, access_mode FROM `{!_MYSQL_PREFIX!}_admins_acls` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		list($aid, $act, $wht, $mode) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare data for the row template
		$content = array(
			'sw'               => $SW,
			'id'               => $id,
			'admins_selection' => generateOptionList('admins', 'id', 'login', $aid, 'default_acl'),
			'action_selection' => ADMIN_MENU_SELECTION('action', $act, $id),
			'what_selection'   => ADMIN_MENU_SELECTION('what', $wht, $id),
			'mode_options'     => generateOptionList(
				'/ARRAY/',
				array('allow', 'deny'),
				array(
					getMessage('ADMINS_ALLOW_MODE'),
					getMessage('ADMINS_DENY_MODE')
				),
				$mode
			),
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE('admin_config_admins_edit_row', true, $content);
		$SW = 3 - $SW;
	}
	define('__ACL_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE('admin_config_admins_edit');
} elseif ((REQUEST_ISSET_POST('change')) && ($SEL > 0)) {
	// Change entries
	foreach (REQUEST_POST('sel') as $id => $selected) {
		// Secure ID
		$id = bigintval($id);

		// Update entries
		SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_admins_acls` SET admin_id=%s, action_menu='%s', what_menu='%s', access_mode='%s' WHERE `id`=%s LIMIT 1",
		array(
			REQUEST_POST('admin', $id),
			REQUEST_POST('action_menu', $id),
			REQUEST_POST('what_menu', $id),
			REQUEST_POST('mode', $id),
			$id
		),__FILE__, __LINE__);
	} // END - foreach

	// Update cache when installed
	if (EXT_IS_ACTIVE('cache')) {
		if ($GLOBALS['cache_instance']->loadCacheFile('admins_acls')) $GLOBALS['cache_instance']->destroyCacheFile();

		// Purge menu cache
		cachePurgeAdminMenu(REQUEST_POST('admin', $id));
	} // END - if

	// Entries changed
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_ADMINS_ENTRIES_CHANGED'));
} elseif ((REQUEST_ISSET_POST('del')) && ($SEL > 0)) {
	// Delete ACLs
	$OUT = ''; $SW = 2;
	foreach (REQUEST_POST('sel') as $id => $selected) {
		// Load data for the ID
		$result = SQL_QUERY_ESC("SELECT admin_id, action_menu, what_menu, access_mode FROM `{!_MYSQL_PREFIX!}_admins_acls` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		list($admin, $act, $wht, $mode) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare variables
		if (empty($act)) $act = '---';
		if (empty($wht)) $wht = '---';

		// Get admin mode
		$mode = getMessage('ADMINS_'.strtoupper($mode).'_MODE');

		// Generate link
		$admin = generateAdminLink($admin);

		// Prepare data for the row template
		$content = array(
			'sw'     => $SW,
			'id'     => $id,
			'admin'  => $admin,
			'action' => $act,
			'what'   => $wht,
			'mode'   => $mode,
		);

		// Load row template and switch colors
		$OUT .= LOAD_TEMPLATE('admin_config_admins_del_row', true, $content);
		$SW = 3 - $SW;
	} // END - foreach
	define('__ACL_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE('admin_config_admins_del');
} elseif ((REQUEST_ISSET_POST('remove')) && ($SEL > 0)) {
	// Remove entries
	// @TODO Rewrite this to filter 'run_sqls'
	foreach (REQUEST_POST('sel') as $id => $selected) {
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_admins_acls` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)),__FILE__, __LINE__);
	} // END - foreach

	// Update cache when installed
	if (EXT_IS_ACTIVE('cache')) {
		if ($GLOBALS['cache_instance']->loadCacheFile('admins_acls')) $GLOBALS['cache_instance']->destroyCacheFile();

		// @TODO This causes the whole (!) menu cache being rebuild
		cachePurgeAdminMenu();
	} // END - if

	// Entries deleted
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_ADMINS_ENTRIES_DELETED'));
} elseif (REQUEST_ISSET_POST('add')) {
	// Check if everything is fine...
	$mode = getAdminDefaultAcl(bigintval(REQUEST_POST('admin_id')));

	// Default ACL is false
	$ACL = false;
	if (REQUEST_ISSET_POST('what_menu')) {
		// Check parent ACL
		$ACL = adminsCheckAdminAcl(getModeAction('admin', REQUEST_POST('what_menu')), '');
	} // END - if

	if (($mode != REQUEST_POST('mode')) || ($ACL)) {
		// Mode is fine
		$BOTH = ((REQUEST_ISSET_POST('action_menu')) && (REQUEST_ISSET_POST('what_menu')));
		if (((REQUEST_ISSET_POST('action_menu')) || (REQUEST_ISSET_POST('what_menu'))) && (!$BOTH)) {
			// Main or sub menu selected
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{!_MYSQL_PREFIX!}_admins_acls` WHERE admin_id=%s AND action_menu='%s' AND what_menu='%s' LIMIT 1",
				array(bigintval(REQUEST_POST('admin_id')), REQUEST_POST('action_menu'), REQUEST_POST('what_menu')), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 0) {
				// Finally add the new ACL
				SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_admins_acls` (admin_id, action_menu, what_menu, access_mode)
VALUES ('%s','%s','%s','%s')",
				array(
					bigintval(REQUEST_POST('admin_id')),
					REQUEST_POST('action_menu'),
					REQUEST_POST('what_menu'),
					REQUEST_POST('mode')
				), __FILE__, __LINE__);
				$content = getMessage('ADMIN_ADMINS_ACL_SAVED');

				// Update cache when installed
				if (EXT_IS_ACTIVE('cache')) {
					if ($GLOBALS['cache_instance']->loadCacheFile('admins_acls')) $GLOBALS['cache_instance']->destroyCacheFile();

					// Purge cache
					cachePurgeAdminMenu(REQUEST_POST('admin_id'), REQUEST_POST('action_menu'), REQUEST_POST('what_menu'));
				} // END - if
			} else {
				// ACL does already exist!
				$content = getMessage('ADMIN_ADMINS_ACL_ALREADY_ADDED');
			}

			// Free memory
			SQL_FREERESULT($result);
		} else {
			// No menu selected makes also no sence...
			$content = getMessage('ADMIN_ADMINS_SELECT_ACTION_WHAT');
		}
	} else {
		// Same mode makes no sence...
		$content = getMessage('ADMIN_ADMINS_SAME_MODE_SELECTED');
	}

	// Display message
	LOAD_TEMPLATE('admin_settings_saved', false, $content);
} else {
	// List all ACLs
	$result_acls = SQL_QUERY("SELECT id, admin_id, action_menu, what_menu, access_mode FROM `{!_MYSQL_PREFIX!}_admins_acls` ORDER BY admin_id, id", __FILE__, __LINE__);

	// Entries found?
	if (SQL_NUMROWS($result_acls) > 0) {
		// List ACLs
		$OUT = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result_acls)) {
			// Prepare variables
			if (empty($content['action_menu'])) $content['action_menu'] = '---';
			if (empty($content['what_menu']))   $content['what_menu']   = '---';

			// Get mode
			$content['access_mode'] = getMessage('ADMINS_'.strtoupper($content['access_mode']).'_MODE');

			// Prepare data for the row template
			$content = array(
				'sw'     => $SW,
				'id'     => $content['id'],
				'admin'  => generateAdminLink($content['admin_id']),
				'action' => $content['action_menu'],
				'what'   => $content['what_menu'],
				'mode'   => $content['access_mode'],
			);

			// Load row template and switch colors
			$OUT .= LOAD_TEMPLATE('admin_config_admins_row', true, $content);
			$SW = 3 - $SW;
		} // END - while

		// Free memory
		SQL_FREERESULT($result);
		define('__ACL_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE('admin_config_admins');
	} // END - if

	// Prepare some constants for the template
	define('_ADMINS_SELECTION', generateOptionList('admins', 'id', 'login', '', 'default_acl'));
	define('_ACTION_SELECTION', ADMIN_MENU_SELECTION('action'));
	define('_WHAT_SELECTION'  , ADMIN_MENU_SELECTION('what'));
	define('_MODE_OPTIONS'    , generateOptionList(
		'/ARRAY/',
		array('allow', 'deny'),
		array(
			getMessage('ADMINS_ALLOW_MODE'),
			getMessage('ADMINS_DENY_MODE')
		)
	));

	// Load template for adding new ACL
	LOAD_TEMPLATE('admin_admins_add_acl');
}

//
?>
