<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/27/2004 *
 * ================                             Last change: 08/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-stats_mods.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Module statistics                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Modul-Statistiken                                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// If var is empty set it to empty
if (!REQUEST_ISSET_GET('mod')) REQUEST_SET_GET('mod', '');

// Check if module was selected
if ((REQUEST_GET('mod') == 'index') || (REQUEST_GET('mod') == 'login')) {
	// Select menu system
	$mod = '';
	switch (REQUEST_GET('mod')) {
		case 'index': $mod = 'guest' ; break;
		case 'login': $mod = 'member'; break;
		default: // Unknown
			DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown mod %s detected.", REQUEST_GET('mod')));
			break;
	} // END - switch

	// Load module's detail statistic
	$result = SQL_QUERY_ESC("SELECT action, title, counter FROM `{!_MYSQL_PREFIX!}_%s_menu` WHERE `what` != '' AND `what` IS NOT NULL ORDER BY counter DESC",
	array($mod), __FILE__, __LINE__);
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// Add color switch
		$content['sw'] = $SW;

		// Load row template
		$OUT .= LOAD_TEMPLATE('admin_mods_stats2_row', true, $content);

		// Switch colors
		$SW = 3 - $SW;
	} // END - while

	// Free memory
	SQL_FREERESULT($result);
	define('__MODS_ROWS', $OUT);

	// Load final template
	LOAD_TEMPLATE('admin_mods_stats2');
} else {
	// Load module statics
	$result = SQL_QUERY("SELECT module, title, clicks FROM `{!_MYSQL_PREFIX!}_mod_reg` ORDER BY clicks DESC, module", __FILE__, __LINE__);
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		if (empty($content['title'])) $content['title'] = '---';

		if (($content['module'] == 'index') || ($content['module'] == 'login')) {
			// Add link to detail statistics
			$content['module'] = "<strong><a href=\"{?URL?}/modules.php?module=admin&amp;what=stats_mods&amp;mod=".$content['module']."\">".$content['module']."</a></strong>";
		} // END - if

		// Add color switch
		$content['sw'] = $SW;

		// Load row template
		$OUT .= LOAD_TEMPLATE('admin_mods_stats_row', true, $content);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);
	define('__MODS_ROWS', $OUT);

	// Load final template
	LOAD_TEMPLATE('admin_mods_stats');
}

//
?>
