<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/16/2003 *
 * ===============                              Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mysql-connect.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Connects to your database                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Verbindet zu Ihrer Datenbank                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Load more function libraries or includes
foreach (array('functions', 'request-functions', 'session-functions', 'code-functions', 'inc-functions', 'language-functions', 'filters', 'mysql-manager', 'extensions', 'handler', 'hooks') as $lib) {
	// Load special functions
	loadIncludeOnce('inc/' . $lib . '.php');
} // END - foreach

// Set error handler
set_error_handler('__errorHandler');

// Disable block-mode by default
enableBlockMode(false);

// Init error handler
initErrorHandler();

// Init request
initRequest();

// Set important header_sent
if (!isset($GLOBALS['header_sent'])) $GLOBALS['header_sent'] = 0;

// Init fatal messages
initFatalMessages();

// Check if this file is writeable or read-only and warn the user
if ((!isInstalling()) && (isInstalled())) {
	// Load "databases" aka static arrays
	loadIncludeOnce('inc/databases.php');

	// Load configuration file(s) here
	loadIncludeOnce('inc/load_config.php');

	// Load database layer here
	loadIncludeOnce('inc/db/lib.php');

	// Check for write-permission for config.php and inc directory
	if (!isModuleSet()) setModule(REQUEST_GET('module'));
	if (!isModuleSet()) setModule('index');

	// CSS array
	EXT_INIT_CSS_FILES();

	if ((!empty($GLOBALS['mysql']['host'])) && (!empty($GLOBALS['mysql']['login'])) && (!empty($GLOBALS['mysql']['password'])) && (!empty($GLOBALS['mysql']['dbase']))) {
		// Connect to DB
		SQL_CONNECT($GLOBALS['mysql']['host'], $GLOBALS['mysql']['login'], $GLOBALS['mysql']['password'], __FILE__, __LINE__);

		// Is the link valid?
		if (SQL_IS_LINK_UP()) {
			// Enable exit on error
			enableExitOnError();

			// Is it a valid resource?
			if (SQL_SELECT_DB($GLOBALS['mysql']['dbase'], __FILE__, __LINE__) === true) {
				// This is required for extension 'optimize' to work
				define('__DB_NAME', $GLOBALS['mysql']['dbase']);

				// Remove MySQL array from namespace
				unset($GLOBALS['mysql']);

				// Load configuration stuff
				loadConfiguration();

				// Init session
				loadIncludeOnce('inc/session.php');

				// Load versions
				loadIncludeOnce('inc/versions.php');

				// Loading patching system is required here...
				loadIncludeOnce('inc/patch-system.php');

				// Run daily reset
				loadIncludeOnce('inc/check-reset.php');

				// Load admin include file if he is admin
				if (IS_ADMIN()) {
					// Administrative functions
					loadIncludeOnce('inc/modules/admin/admin-inc.php');
				} // END - if
				//* DEBUG: */ ADD_POINTS_REFSYSTEM('test', 36, 1000);
				//* DEBUG: */ die();

				// Get all values
				if ((getOutputMode() != 1) && (getOutputMode() != -1)) {
					if (!isModuleSet())  setModule('empty');
					if (!isWhatSet())    setWhat(getWhatFromModule(getModule()));
					if (!isActionSet())  setAction(getModeAction(getModule(), getWhat()));
				} else {
					// Set action/what to empty
					setAction('');
					setWhat('');
				}

				// Run the init filter chain
				runFilterChain('init');

				// Set default 'what' value
				//* DEBUG: */ OUTPUT_HTML('-'.getModule().'/'.getWhat()."-<br />");
				if ((!isWhatSet()) && (!isActionSet()) && (getOutputMode() != 1) && (getOutputMode() != -1)) {
					if (getModule() == 'admin') {
						// Set 'action' value to 'login' in admin menu
						setAction(getModeAction(getModule(), getWhat()));
					} elseif ((getModule() == 'index') || (getModule() == 'login')) {
						// Set 'what' value to 'welcome' in guest and member menu
						setWhat('welcome');
						if (getConfig('index_home') != '') setWhatFromConfig('index_home');
					} else {
						// Anything else like begging link
						setWhat('');
					}
				} // END - if

				// Update sending pool
				if ((getOutputMode() != '1') && (getOutputMode() != '-1')) loadIncludeOnce('inc/pool-update.php'); // Sends out mails in configureable steps

				// Check module for permissions
				$checkModule = checkModulePermissions(getModule());
				if ($checkModule != 'done') {
					// Not fine!
					DEBUG_LOG(__FILE__, __LINE__, sprintf("Check of module %s results in unpexted value: %s",
						getModule(),
						$checkModule
					));
				} // END - if

				// Shall we activate the exchange?
				if (getConfig('activate_xchange') > 0) activateExchange();

				// Is the extension sql_patches installed and at least 0.3.6?
				if (GET_EXT_VERSION('sql_patches') >= '0.3.6') {
					// Generate random number
					setConfigEntry('RAND_NUMBER', generateRandomCode(10, mt_rand(10000, 32766), getUserId(), ''));
				} else {
					// Generate weak (!!!) code
					setConfigEntry('RAND_NUMBER', mt_rand(1000000, 9999999));
				}
			} else {
				// Wrong database?
				addFatalMessage(__FILE__, __LINE__, getMessage('WRONG_DB_SELECTED'));
			}
		} else {
			// No link to database!
			addFatalMessage(__FILE__, __LINE__, getMessage('NO_DB_LINK'));
		}
	} else {
		// Maybe you forgot to enter your MySQL data?
		addFatalMessage(__FILE__, __LINE__, getMessage('MYSQL_DATA_MISSING'));
	}
} else {
	///////////////////////////////////////////////////
	// Include neccessary functions for installation //
	///////////////////////////////////////////////////

	// Default output is 'direct' for HTML output
	setConfigEntry('OUTPUT_MODE', 'direct');

	// This hack prevents a backtrace in CSS output
	if (getOutputMode() == '1') {
		// Problem with config so set output mode
		setConfigEntry('OUTPUT_MODE', 'render');
	} // END - if

	// Set other missing variables
	if (!isOutputModeSet()) setOutputMode('0');

	// Include databases.php
	loadIncludeOnce('inc/databases.php');

	// Init session
	loadIncludeOnce('inc/session.php');

	// Load versions
	loadIncludeOnce('inc/versions.php');

	// Check if we are in installation routine
	if ((!isInstalling()) && (getOutputMode() != '1') && (getOutputMode() != -1)) {
		// Redirect to the installation system
		redirectToUrl('install.php');
	} // END - if

	// Double-check installation mode
	if ((!isInstalled()) || (!isAdminRegistered())) {
		// Check for file permissions
		if (!isIncludeWriteable('config')) {
			addFatalMessage(__FILE__, __LINE__, getMessage('CONFIG_IS_WRITE_PROTECTED'));
		} // END - if
		if (!isIncludeWriteable('dummy')) {
			addFatalMessage(__FILE__, __LINE__, getMessage('DUMMY_IS_WRITE_PROTECTED'));
		} // END - if
		if (!isIncludeWriteable('.secret/dummy')) {
			addFatalMessage(__FILE__, __LINE__, getMessage('SECRET_IS_WRITE_PROTECTED'));
		} // END - if
	} // END - if

	// Run the init filter chain
	runFilterChain('init');

	// Load extension 'sql_patches'
	LOAD_EXTENSION('sql_patches');

	// Load configuration file(s) here
	loadIncludeOnce('inc/load_config.php');
}

// Init session
loadIncludeOnce('inc/session.php');

// Load versions
loadIncludeOnce('inc/versions.php');

if ((getTotalFatalErrors() > 0) && (isInstalled()) && (!isInstalling()) && (getOutputMode() != '1')) {
	// One or more fatal error(s) occur during connect...
	loadIncludeOnce('inc/header.php');
	loadIncludeOnce('inc/fatal_errors.php');
	loadIncludeOnce('inc/footer.php');
} // END - if

//
?>
